'use strict';

exports.__esModule = true;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const fileRegex = /^(?!.*\.(jsx?|tsx?|json)$).*/; // match everything except .jsx? and .tsx? and json

const commandResourceLoader = {
  test: fileRegex,
  use: {
    loader: '@skpm/file-loader',
    query: {
      raw: true,
      outputPath(url) {
        return _path2.default.posix.join('..', 'Resources', '_webpack_resources', url);
      },
      publicPath(url) {
        return `"file://" + context.plugin.urlForResourceNamed("${url.split('../Resources/')[1]}").path()`;
      }
    }
  }
};

exports.default = commandResourceLoader;