'use strict';

exports.__esModule = true;

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

var _getSketchVersion = require('@skpm/utils/getSketchVersion');

var _getSketchVersion2 = _interopRequireDefault(_getSketchVersion);

var _webpackShellPlugin = require('./webpackShellPlugin');

var _webpackShellPlugin2 = _interopRequireDefault(_webpackShellPlugin);

var _sketchCommandPlugin = require('./sketchCommandPlugin');

var _sketchCommandPlugin2 = _interopRequireDefault(_sketchCommandPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (output, commandIdentifier) {
    const sketchVersion = yield (0, _getSketchVersion2.default)();

    let command;

    if (sketchVersion && _semver2.default.satisfies(sketchVersion, '^43.0.0')) {
      command = new _sketchCommandPlugin2.default({
        bundleURL: output,
        commandIdentifier
      });
    }

    if (!sketchVersion || _semver2.default.satisfies(sketchVersion, '^44.0.0')) {
      command = new _webpackShellPlugin2.default({
        script: (0, _webpackShellPlugin.sketchtoolRunCommand)(output, commandIdentifier)
      });
    }

    if (sketchVersion && _semver2.default.satisfies(sketchVersion, '>= 45.0.0')) {
      command = new _webpackShellPlugin2.default({
        script: (0, _webpackShellPlugin.sketchtoolRunCommand)(output, commandIdentifier, {
          withoutActivating: true
        })
      });
    }

    return command;
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();