// dump-lib is a public domain tool for inspecting emscripten-library-decorator output.
var util = require('util'); // tslint:disable-line
var fs = require('fs'); // tslint:disable-line
function dump(path) {
    var output = [];
    /* tslint:disable:no-unused-variable */
    var lib = {};
    var LibraryManager = { library: lib };
    function mergeInto(dst, src) {
        for (var _i = 0, _a = Object.keys(src); _i < _a.length; _i++) {
            var key = _a[_i];
            dst[key] = src[key];
        }
    }
    /* tslint:enable:no-unused-variable */
    eval(fs.readFileSync(path, 'utf-8'));
    for (var _i = 0, _a = Object.keys(lib); _i < _a.length; _i++) {
        var key = _a[_i];
        if (!key.match(/__deps$/)) {
            var item = lib[key];
            switch (typeof (item)) {
                case 'function':
                    item = item.toString().replace(/^(function) *([^(]*)/, '$1 _' + key);
                    break;
                case 'object':
                    item = 'var _' + key + ' = ' + util.inspect(item) + ';';
                    break;
                default:
                    break;
            }
            output.push(item);
        }
    }
    return (output.join('\n'));
}
// tslint:disable-next-line:no-console
console.log(dump(process.argv[2]));
